#include <sdcc-lib.h>
#include <pic12f675.h>	// /usr/share/sdcc/non-free/include/pic14/pic12f675.h

#include "inline.h"
#include "libwait.h"

__code unsigned char __at 0x2000 id_location[] = {'A', 'B', 'C', 'D'};

unsigned int __at 0x2007 __config =
	_CPD_OFF &
	_CP_OFF &
	_BODEN_ON &	// for 2.1V
	_MCLRE_OFF &
	_PWRTE_OFF &
	_WDT_OFF &
	_INTRC_OSC_NOCLKOUT;

__code unsigned char __at 0x2100 eedata[] = {'d', 'u', 'm', 'm', 'y', 0 };

#define	LED1	GPIO0

void Intr(void) __interrupt 0 {
	T0IF = 0;						// Clear timer interrupt
}

/*			  _______
	Vcc		-|	 U	 |-	GND
	NC		-|5		0|-	LED1
	NC		-|4		1|-	NC
	NC		-|3_____2|-	NC
*/

void main(void) {
				//  --543210
	GPIO		= 0b00000000;		// GPIO3: input only
	CMCON		= 0b00000111;
	ANSEL		= 0b00000000;
	TRISIO		= 0b00001000;		// 1: 入力, 0: 出力

	OPTION_REG	= 0b11111111;		// 初期値:0b11111111
									// 7:GPIOプルアップ(0:使用する)
									// 6:GP2割り込みポート変化選択(0:立下り)
									// 5:TMR0クロックソース選択ビット(0:内部)
									// 4:TMR0加算タイミング(0:立上り)
									// 3:プリスケーラ割り当てビット(0:TMR0)
									// 2~0プリスケーラレート選択ビット(011:1/16)
									// 4MHz => 1MHz = 1,000,000 / 16 / 256 = 244Hz

	INTCON		= 0b00000000;		// 初期値:0b00000000
									// 7:GIE  Global Interrupt Enable bit
									// 6:PEIE Peripheral Interrupt Enable bit
									// 5:T0IE TMR0 Overflow Interrupt Enable bit
									// 4:INTE GP2/INT External Interrupt Enable bit
									// 3:GPIE GPIO Port Change Interrupt Enable bit
									// 2:T0IF TMR0 Overflow Interrupt Flag bit
									// 1:INTF GP2/INT External Interrupt Flag bit
									// 0:GPIF GPIO Port Change Interrupt Flag bit

	PIR1		= 0b00000000;		// 初期値:0b00000000(フラグ)
	PIE1		= 0b00000000;		// 初期値:0b00000000(イネーブル)
									// 7:EEIE EE Write Complete Interrupt Enable Bit
									// 6:ADIE A/D Converter Interrupt Enable bit
									// 3:CMIE Comparator Interrupt Enable bit
									// 0:TMR1IE TMR1 Overflow Interrupt Enable bit

	T1CON		= 0b00000000;		// 初期値:0b00000000
									// 6:TMR1GE Timer1 Gate Enable bit
									// 5~4:T1CKPS Timer1 Input Clock Prescale Select bits(00:1/1, 11:1/8)
									// 3:T1OSCEN Timer1 Oscillator Enable Control bit(1:Enable)
									// 2:T1SYNC Timer1 External Clock Input Synchronization Control bit(1:Sync)
									// 1:TMR1CS Timer1 Clock Source Select bit(0:Internal)
									// 0:TMR1ON Timer1 On bit(1:Enable)

//	forCalibOsc();

	//--------------------------------------------------------------------------
	//
	//	Main Loop
	//
	while(1) {
		LED1 = 1;
		waitL(5);

		LED1 = 0;
		waitL(10);
	}
}

