#include "libwait.h"

volatile unsigned char waitCntS;
volatile unsigned char waitCntM;
volatile unsigned char waitCntL;

void _waitS() {
	__asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(小)
						;			;
						;			;		* 4MHz 時
						;			;				LD		A, 10					; 10を与えると、
						;			;				CALL	WAITnx3p5u				; 2行で 10 x 3 + 5 = 35us 消費
						;			;
WAITnx3p5u:					;			WAITnx3p5u:
		BANKSEL	_waitCntS		;							BANKSEL	_waitCntS
		movwf	_waitCntS		;							LD		(_waitCntS), A
WAITnx3p5u1:					;			WAITnx3p5u1:
		decfsz	_waitCntS, F		
		goto	WAITnx3p5u1		;							DJNZ	(_waitCntS), WAITnx3p5u1
						;			;				RET
	__endasm;
}

void _waitM() {
	__asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(中)
						;			;
						;			;		* 4MHz 時
						;			;				LD		A, 20					; 0.01秒の場合、20を与えると、
						;			;				CALL	WAITnx500m35u			; 2行で 20 x 500 - 35 = 9.965ms 消費する
						;			;
WAITnx500m35u:					;			WAITnx500m35u:
		BANKSEL	_waitCntM		;							BANKSEL	_waitCntM
		movwf	_waitCntM		;							LD		(_waitCntM), A
		goto	WAITnx500m35u2		;							JP		WAITnx500m35u2
WAITnx500m35u1:	nop				;			WAITnx500m35u1:	NOP
		movlw	12			;							LD		A, 12
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				;  12 x 3 + 5 =  41us
WAITnx500m35u2:	movlw	150			;			WAITnx500m35u2:	LD		A, 150
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				; 150 x 3 + 5 = 455us
		BANKSEL	_waitCntM		;							BANKSEL	_waitCntM
		decfsz	_waitCntM, F		
		goto	WAITnx500m35u1		;							DJNZ	(_waitCntM), WAITnx500m35u1
						;			;				RET
	__endasm;
}

void _waitL() {
	__asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	時間待ち(大)
						;			;
						;			;		* 4MHz 時
						;			;				LD		A, 10					; 1秒の場合、10を与えると、
						;			;				CALL	WAITnx01sm25u			; 2行で 10 x 100ms - 25us 消費する
						;			;
WAITnx01sm25u:					;			WAITnx01sm25u:
		BANKSEL	_waitCntL		;							BANKSEL	_waitCntL
		movwf	_waitCntL		;							LD		(_waitCntL), A
		goto	WAITnx01sm25u2		;							JP		WAITnx01sm25u2
WAITnx01sm25u1:	movlw	9			;			WAITnx01sm25u1:	LD		A, 9
		call	WAITnx3p5u		;							CALL	WAITnx3p5u
WAITnx01sm25u2:	movlw	200			;			WAITnx01sm25u2:	LD		A, 200
		call	WAITnx500m35u		;							CALL	WAITnx500m35u
		BANKSEL	_waitCntL		;							BANKSEL	_waitCntL
		decfsz	_waitCntL, F		
		goto	WAITnx01sm25u1		;							DJNZ	(_waitCntL), WAITnx01sm25u1
						;			;				RET
	__endasm;
}

void forCalibOsc() {
	__asm
						;			;-------------------------------------------------------------------------------
						;			;
						;			;	20秒周期LED点滅(クロック速度計測用)
						;			;
ForCalibOsc:					;			ForCalibOsc:
		bsf	_CALIB_PORT, _CALIB_LEDBIT;							SET		_CALIB_LEDBIT, (_CALIB_PORT)
						;	
		movlw	100			;							LD		A, 100
		call	WAITnx01sm25u		;							CALL	WAITnx01sm25u			; 100 x 100ms - 25us
		movlw	6			;							LD		A, 6
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				;   6 x 3 + 5 = 23us
						;	
		bcf	_CALIB_PORT, _CALIB_LEDBIT;							RES		_CALIB_LEDBIT, (_CALIB_PORT)
						;	
		movlw	100			;							LD		A, 100
		call	WAITnx01sm25u		;							CALL	WAITnx01sm25u			; 100 x 100ms - 25us
		movlw	6			;							LD		A, 6
		call	WAITnx3p5u		;							CALL	WAITnx3p5u				;   6 x 3 + 5 = 23us
						;	
		goto	ForCalibOsc		;							JP		ForCalibOsc
	__endasm;
}

